import { Client, ClientOptions } from "discord.js";
import CommandHandler from "../handlers/CommandHandler";
import EventHandler from "../handlers/EventHandler";
export interface ExtendedClientOptions {
    prefix: string;
    baseDirectoryUrl: string;
}
export default class TwokeiClient<Ready extends boolean = boolean> extends Client<Ready> {
    baseDirectoryUrl: string;
    prefix: string;
    commandHandler: CommandHandler;
    eventHandler: EventHandler;
    constructor(options: ClientOptions);
}
declare module 'discord.js' {
    interface Client {
        baseDirectoryUrl: string;
    }
    interface ClientOptions extends ExtendedClientOptions {
    }
}
