"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const CommandHandler_1 = __importDefault(require("../handlers/CommandHandler"));
const EventHandler_1 = __importDefault(require("../handlers/EventHandler"));
class TwokeiClient extends discord_js_1.Client {
    constructor(options) {
        super(options);
        this.prefix = options.prefix;
        this.baseDirectoryUrl = options.baseDirectoryUrl;
        this.commandHandler = new CommandHandler_1.default(this, options.baseDirectoryUrl);
        this.eventHandler = new EventHandler_1.default(this, options.baseDirectoryUrl);
        this.on('ready', (client) => {
            this.on('messageCreate', (message) => {
                this.commandHandler.performCommand(message);
            });
        });
    }
}
exports.default = TwokeiClient;
