"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const loader_1 = __importDefault(require("../utils/loader"));
class EventHandler {
    constructor(client, dir) {
        this.setup(client, dir);
        this.client = client;
    }
    setup(client, dir) {
        return __awaiter(this, void 0, void 0, function* () {
            for (const [filePath, fileName] of loader_1.default(path_1.join(dir, 'listeners'))) {
                this.registerEvent(client, filePath, fileName);
            }
        });
    }
    registerEvent(client, filePath, fileName) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let Event = (yield Promise.resolve().then(() => __importStar(require(filePath))).then((e) => { var _a; return (_a = e.default) !== null && _a !== void 0 ? _a : e; }));
                if (!Event) {
                    console.log('No event found for file: ' + filePath);
                    return;
                }
                const { event: eventName, run, onLoad } = new Event({ client: client });
                if (!Event || !eventName) {
                    console.error('No EventName found on ', filePath);
                    return;
                }
                console.log('Loading event: ', Event, eventName, run);
                this.client.on(eventName, (...params) => run(...params));
            }
            catch (e) {
                console.log(e);
            }
        });
    }
}
exports.default = EventHandler;
