import { ClientEvents } from "discord.js";
import TwokeiClient from "../client/TwokeiClient";
declare type RunParams<E extends keyof ClientEvents> = ClientEvents[E];
export interface IDiscordListenerOptions {
    event: string;
    once: boolean;
}
export default abstract class DiscordListener<E extends keyof ClientEvents> {
    readonly event: string;
    readonly once: boolean;
    enabled: boolean;
    constructor({ event, once }: IDiscordListenerOptions);
    onLoad(client: TwokeiClient): void;
    onUnload(client: TwokeiClient): void;
    abstract run(...args: RunParams<E>): void;
}
export {};
